#!/usr/bin/perl -w
use strict;
#use lib qw ( @@ LIBDIR@@ );
use lib qw ( /usr/lib/perl5/5.6.1/ );
# my $kas=/"/";
use strict;
use Misc;
use Misc qw ( OpenConfig SaveConfig );
use Lstatobj;

$ENV{'PATH'} = '/bin:/usr/bin:/sbin:/usr/sbin';

#some vaiables form configure script
my $disks=1;
my $disksinfo="";

my $interfaces=1;
my $interfacesinfo="";

my $mounts=1;
my $mountsinfo="";
#www server group and user
my $wwwuser='http';
my $wwwgroup='http';

my @content;

#set default width of graphs
my $width=650;
my $df=$config {'DF'};
my $pagesdir=$config {'PAGE_DIR'};
my $objdir=$config {'OBJ_DIR'};

#find filesystems from df
if ($mounts && (! $mountsinfo)) {
#autodetect
my @filesystems;
@content = `$df -l -T -x smbfs -x nfs -x supermount` ;
#print @content;
foreach (@content) {
 chomp;
 if ( /^\// ) {
  my @line = split;
  push (@filesystems, $line[6]);
 }
}
my @filesystems2 = split(/,/,join(',',@filesystems));
$mountsinfo=join (':',@filesystems2); #convert to one line
}


#find interfaces
if ($interfaces && (! $interfacesinfo)) {
my @inters;
#detect network interface
my $procdev=$config{'PROC_INT_FILE'};
open (FILE, "<$procdev") or die "Cant open file $procdev: $!\n";
@content=<FILE>;
close FILE;
foreach (@content) {
 chomp;
 if ( /^\s*(\w+)\:/ ) {
  push (@inters, $1) if ($1 ne 'lo');
 }
}
#join arguments with ',' separator
my @inters2 = split(/,/,join(',',@inters));
$interfacesinfo=join (':',@inters2); #convert to one line

}


#find disks and partitions
if ($disks && (! $disksinfo)){
#detect disks
my @diskstab;
my $procpart=$config{'PROC_PART_FILE'};
#build list valid disks
open (FILE, "<$procpart") || die "Cant open $procpart: $! \n";
@content = <FILE>;
close FILE;

foreach my $line ( @content ) {
 $line =~ s/^\s+//g;
 my @info = split (/\s+/,$line,5);
 if (defined ($info[3]) ) {
 if ($info[3] =~ /^[sh]d[a-z]+$/) {
 push (@diskstab, $info[3]);
 }
 }
}
#join arguments with ',' separator
my @diskstab2 = split(/,/,join(',',@diskstab));
$disksinfo=join (':',@diskstab2); #convert to one line
}


#create objects-------------------------------------------------
#for system page

 #create load object
 my $pagefile="$pagesdir\/system";
 my $newpage= ( ! -e $pagefile );
my $obj;
my $objname;
my  $filename;

 if ($newpage) {
 $obj=CreateObjByClass ('TLOADGrapher');
 open (FILE2, ">>$pagefile" ) or  die "Cant write page $pagefile: $!\n";
 print FILE2 "<H1>\@\@PAGE_NAME\@\@</H1>\n" if $newpage;
 $objname="load1";
 $filename = "$objdir$objname\.obj";
 if ( ! -e $filename) {
 $obj->name ($objname);
 $obj->Save;
 print FILE2 "<P>\n\@\@\$$objname\@\@\n";
 }

 $objname="cpu1";
 $filename = "$objdir$objname\.obj";
 if ( ! -e $filename) {
 $obj=CreateObjByClass ('TCPUGrapher');
 $obj->name ($objname);
 $obj->Save;
 print FILE2 "<P>\n\@\@\$$objname\@\@\n";
 }

 $objname="mem1";
 $filename = "$objdir$objname\.obj";
 if ( ! -e $filename) {
 $obj=CreateObjByClass ('TMEMGrapher');
 $obj->name ($objname);
 $obj->Save;
 print FILE2 "<P>\n\@\@\$$objname\@\@\n";
 }
 close FILE2; #close system page

 #creating LOCK for fresh installation
 my $lockfile=$config {'LSTAT_LCK'};
 if ($lockfile) {
 if ( ! -f $lockfile ) {
  print "Setting LOCK file \n";
  open (FILE2, ">$lockfile");
  close (FILE2);
 }
 }
}


$pagefile="$pagesdir\/disk";
$newpage= ( ! -e $pagefile );

if ($newpage) {

 open (FILE2, ">>$pagefile" ) or  die "Cant write page $pagefile: $!\n";
 print FILE2 "<H1>\@\@PAGE_NAME\@\@</H1>\n" if $newpage;
 close FILE2;


if ($mountsinfo) {
 #create partition object
 my @parttab = split (/:/,$mountsinfo);
 $objname="part1";
 $filename = "$objdir$objname\.obj";
 if (! -e $filename) {
 $obj=CreateObjByClass ('TPARTGrapher');
 $obj->name ($objname);
 my $ref = $obj->{'DESC'}{'ADV'};
 for (my $i=0; $i<@parttab; $i++) {
 my %info;
 $info {'MOUNT'}=$parttab[$i];
 $info {'COLOR'}="";
 $info {'DESC'}="";
 push (@$ref, { %info });
 }
 $obj->Save;

  open (FILE2, ">>$pagefile" ) or  die "Cant write to $pagefile: $!\n";
  print FILE2 "<P>\n\@\@\$$objname\@\@\n";
  close FILE2;
 }
}


if ($disksinfo) {
 #create disk objects
 my @disktab = split (/:/,$disksinfo);
 open (FILE2, ">>$pagefile" ) or  die "Cant write to $pagefile: $!\n";;;
 for (my $i=0; $i<@disktab; $i++) {
  my $j = $i +1;
  $objname="disk$j";
  $filename = "$objdir$objname\.obj";
  if (! -e $filename ) {
  $obj=CreateObjByClass ('TDISKGrapher');
  $obj->name ($objname);
  $obj->{'DESC'}{'TITLE'} .=" $disktab[$i]";
  $obj->{'DESC'}{'DISK'} =$disktab[$i];
  $obj->Save;
  print FILE2 "<P>\n\@\@\$$objname\@\@\n";
 }
 }

}
 close FILE2;
}

$pagefile="$pagesdir\/net";
$newpage= ( ! -e $pagefile );

if ($newpage) {
 open (FILE2, ">>$pagefile" ) or  die "Cant write page $pagefile: $!\n";
 print FILE2 "<H1>\@\@PAGE_NAME\@\@</H1>\n" if $newpage;
 close FILE2;


if ($interfacesinfo) {
 #create interface objects
 my @inttab = split (/:/,$interfacesinfo);
 open (FILE2, ">>$pagefile" ) or  die "Cant write to $pagefile: $!\n";;;
 for (my $i=0; $i<@inttab; $i++) {
  my $j = $i +1;
  $objname="int$j";
  $filename = "$objdir$objname\.obj";
  if (! -e $filename ) {
  $obj=CreateObjByClass ('TINTGrapher');
  $obj->name ($objname);
  $obj->{'DESC'}{'TITLE'} .="  $inttab[$i]";
  $obj->{'DESC'}{'INTERFACE'} =$inttab[$i];
  $obj->Save;
  print FILE2 "<P>\n\@\@\$$objname\@\@\n";
 }
 }

}
 close FILE2;
}

#create page for custom statistic
$pagefile="$pagesdir\/custom";
if ( ! -e $pagefile ) {

 open (FILE2, ">>$pagefile" ) or  die "Cant write page $pagefile: $!\n";
 if ($newpage) {
 print FILE2 "<H1>\@\@PAGE_NAME\@\@</H1>\n";
 print FILE2 "\@\@CUSTOM_MENU\@\@\n<HR><P>\n";
 }
 close FILE2;
}

#merge config files
my $newusercfg=$pagesdir.'user.config.new';
my %tempconfig;

if ( -f $newusercfg ) {
 print "Merging user config\n";
 OpenConfig ($newusercfg, \%tempconfig); #open new
 OpenConfig ($config {'USERCONFIG'}, \%tempconfig); #open old
 SaveConfig ($config {'USERCONFIG'}, \%tempconfig); #save sum
 unlink ($newusercfg); #unlink new config
}

%tempconfig=();
my $newcfg=$config {'CONFIGFILE'}.'.new';
if ( -f $newcfg ) {
 print "Merging system config\n";
 OpenConfig ($newcfg, \%tempconfig); #open new
 OpenConfig ($config {'CONFIGFILE'}, \%tempconfig); #open old
 SaveConfig ($config {'CONFIGFILE'}, \%tempconfig); #save sum
 unlink ($newcfg); #unlink new config
}

#change owner of objfiles and pages
system ("chown $wwwuser:$wwwgroup $objdir*");
system ("chown $wwwuser:$wwwgroup $pagesdir*");

#notify LSTATd to reload objects

my $err = SendMsg (6,0); #send message fo daemon for reloading object and creating rrd files;

