package Misc;
use strict;
use Carp;
use Socket;
require  Exporter;

#--------MISC------------------------------------------------
use vars qw ( @ISA @EXPORT @EXPORT_OK %config @defcolour $instance %dict $lastrun $valid_langs);
@ISA = qw(Exporter);
@EXPORT= qw ( %config Gen SendMsg show_file show_command get_page_index IF_DEMO $instance %dict LoadLangData RegisterClass
	CreateObjByClass $lastrun ); #export by default
@EXPORT_OK = qw ( OpenUserConfig SaveUserConfig @defcolour GetClassesNames $valid_langs ConvB SetLang OpenConfig SaveConfig ); #optional export

@defcolour = ('ff0000','0000ff','00A000','000000','ff00ff','800000','ffff00','00ffff','ff6600','808080'); #table defaults colours


$instance=0; #number for marking instances objects

#for language options
my $LANG;
my $DEF_SKIN;
my $SKIN;
#my $valid_langs;

my %LoadedLangfile;

#array of availble classes
my %Classes;


#program's config
BEGIN {
%config =();
%dict = (); #dictionary for language conversion


#my $configfile='@@ ETCDIR@@config';
#my $userconfigfile='@@ PAGESDIR@@user.config';
my $configfile='/etc/lstat/config';
my $userconfigfile='/var/lib/lstat/pages/user.config';

OpenConfig ($userconfigfile, \%config);   #read user config
OpenConfig ($configfile, \%config);     #read main config

$DEF_SKIN='sky';
$SKIN=$DEF_SKIN;

#list of valid languages
$valid_langs ='en,pl';

$LANG= $config{'LANG'} if (defined ($config{'LANG'}));

#LANG not set in config
if (! defined ($LANG) ) {
  SetLang ('auto'); #load info about language
} else {
 SetLang ($LANG); #load info about language
}
$SKIN=$config{'SKIN'} if (defined ($config{'SKIN'}));
#load skin info data
my $skininfofile =  $config  {'TEMPLATE_DIR'}.'skins/'.$SKIN.'/skininfo';  #skin info file
OpenConfig ($skininfofile, \%dict);

#set default url
$config{'IMG'} = $config{'SKIN_URL'}.$SKIN.'/uni/';

#set language
sub SetLang {
 my $lang=shift;
 $lang='en' if ($lang =~ /\W/);
 
 if ($lang =~ /auto/) {
 #try autodetect
  $lang="en"; #set default

 if (defined ($ENV {'HTTP_ACCEPT_LANGUAGE'} )) {
  #run in cgi env
  my $lang2 =$ENV {'HTTP_ACCEPT_LANGUAGE'} ;
  $lang2 =~ /^(\w+)/;
  $lang2 = $1;
  if (defined ($lang2)) {
  $lang= $lang2 if ( $valid_langs =~ /$lang2/i);
  }
 }
}

 if ( $valid_langs =~ /$lang/i) {
  $LANG= $lang;
  LoadLangData ('', 'langinfo'); #load info about language
  #set default url
 $config{'DOC'} = $config{'DOC_URL'}.$LANG.'/';
 $config{'LANG_IMG'} = $config{'SKIN_URL'}.$SKIN.'/'.$LANG.'/';
  }
}

sub OpenUserConfig {
 my $refhash = shift;
 OpenConfig ($userconfigfile, $refhash);
}

#choose available language & load
sub LoadLangData {
 my $dir = shift;
 my $filename = shift;
 $dir = 'standard' if (! $dir);
 my $id = $dir.'/'.$filename;

 if ( ! defined (  $LoadedLangfile {$id}) )  { #check if already loaded
 my $langdir =  $config  {'TEMPLATE_DIR'}.$dir.'/';  #lang directory
 my $langfile = $langdir.$LANG.'/'.$filename ;
 $langfile = $langdir.'default/'.$filename if ( ! -e $langfile ); #try default language if not exists

 #load translation data into dictionary

 open (FILE, "<$langfile") || croak ("Cant open language data file $langfile : $!\n");
 my @data = <FILE>;
 close FILE;

#process all lines
foreach my $line (@data){
 chomp ($line);
 if ($line =~ /^\w.*=/) {
  my ($key, $value) = split (/=/,$line,2);
  $dict {$key} =$value;
  }
 }

 $LoadedLangfile {$id} = 1; #mark already loaded
 }
}

#read config into memory
sub OpenConfig {
my $configfile = shift;
my $refhash = shift;
open (FILE, "<$configfile") || croak ("Cant open configfile $configfile : $!\n");
my @cfg = <FILE>;
close FILE;

#process config file
foreach my $line (@cfg){
 chomp ($line);
 if ($line=~/^\w/) {
  my ($key, $value) = split (/=/,$line,2);
  $$refhash {$key} =$value;
  }
 }
}



sub SaveConfig {
my $filename = shift;
my $refhash = shift;
open (FILE, ">$filename") || croak ("Cant save configfile $filename : $!\n");
#process config file
while (my ($key, $value) = each %$refhash) {
 print FILE "$key=$value\n";
}
close FILE;

}

sub SaveUserConfig {
my $refhash = shift;
SaveConfig ($userconfigfile, $refhash);
}

} #end BEGIN


#test if DEMO version
sub IF_DEMO {
 my $result = 0;
 $result = $config {'DEMO'} if (defined ($config {'DEMO'}));
 return ($result);
}



sub FindTemplate {
 my $template=shift; #filename to find
 my $myskin = shift;
 my $skindir =  $config  {'TEMPLATE_DIR'}.'skins/'.$myskin.'/';  #skin directory
 my $skinfile=$skindir.$LANG.'/';
 my $TemplateFile = $skinfile.$template;
 return ($TemplateFile);
}


#genreating page
sub Gen {
 my $RefTags = shift; #Reference to tags array
 my $template = shift; #template to view
 my $kind = shift; #kind of template
 my $TemplateFile;
 my $old_img;
 my $old_langimg;
 my $use_def = 0;

 if (defined ($kind)) { # 1 - from skins directory
  $TemplateFile =  FindTemplate ($template, $SKIN);
  if ( ! -e $TemplateFile) {  #use default template if not extist
  $use_def =1;
  $old_img = $RefTags ->{'IMG'};
  $old_langimg = $RefTags ->{'LANG_IMG'};
  $TemplateFile =  FindTemplate ($template, $DEF_SKIN);
  #change references to default skin
  $RefTags ->{'IMG'} = $config{'SKIN_URL'}.$DEF_SKIN.'/uni/';
  $RefTags ->{'LANG_IMG'} = $config{'SKIN_URL'}.$DEF_SKIN.'/'.$LANG.'/';
  }
 } else
  {
  $TemplateFile = $config  {'PAGE_DIR'}.$template;
  }

 open (FILE, "<$TemplateFile" ) || croak "Can't open template file $TemplateFile: $! \n";
 my @content = <FILE>;  #load content template into memory
 close FILE;
 #printing template file
 foreach (@content)  {
 #find @@ tags @@
 if (/\@\@[\w\$][^\@]+\@\@/ ) {
 #tag found
  my $linecopy = $_;
  my $linecopy2 = $_;

  while ($linecopy =~ /\@\@([\w\$][^\@]+)\@\@/g ) {

  my $tag = $1; #tag name
  my $i = index ($linecopy2, "\@\@$tag\@\@");

  if ($i ) { print substr ($linecopy2 , 0, $i )}; #print content before tag
  $linecopy2 = substr ($linecopy2, $i+4+length ($tag), 65535); #delete taginfo
  #find tag value
  if (defined ($RefTags-> { $tag } )) {
   if (! ref ($RefTags-> { $tag })) {
     print $RefTags-> { $tag }; #found text in Tags array
    } else  {
     #tag as referencr\e
     if ( ref ($RefTags-> { $tag }) eq "ARRAY") {
      #print all strings in array
     foreach (@{$RefTags-> { $tag }}) {
      print;
      }
     } else {
     $RefTags-> { $tag }->($RefTags); #run this code
     }
    }} #end found tag
     else {
     #unknown tag
     if ($tag =~ /^(\w*)\$(.*)$/ )
      {
       if (!$1) { #empty fistr arg, default for draw object
        $RefTags-> { 'DRAW' }->($2); #draw object
       } else
        { #run external code
         $RefTags-> { $1 }->($RefTags, $2);
        }
      }
       elsif ( $tag eq 'ALL' ) {
                         #print all tags
                        foreach my $key (keys %$RefTags ) {
                          print "<B>$key</B>=$RefTags->{$key}<BR>\n";
                         }       }
      else {
     #really unknown tag
      croak "Unknown tag $tag in $TemplateFile \n";
      }
    }

  } ##while
  print $linecopy2; #print rest of line

 } #if 1
  else  {print} #print simply HTML line
 } #forech
if ( $use_def ) {
 #restore skin info
 $RefTags ->{'IMG'} = $old_img ;
 $RefTags ->{'LANG_IMG'} =  $old_langimg ;
}

}

#----------------------------------------------------------------------
#send message to daemon
sub SendMsg {
 my $Msg=shift;
 my $id = shift;
 my $filename = $config {'SOCKET'};

 socket(SOCK, PF_UNIX, SOCK_STREAM, 0)	|| return "SendMsg socket: $!";
 connect(SOCK, sockaddr_un($filename))	|| return "SendMsg connect: $! \
  (probably <B>lstatd</B> isn't running)";
# $SIG {'CLD'} = "IGNORE";

 # split the program into two processes, identical twins
 my $kidpid;
 die "can't fork: $!" unless defined($kidpid = fork());

 if ($kidpid) {
   my  $rin ='';
   my $line ='';
   vec ($rin, fileno (SOCK),1)=1;
   #wait for data or timeout
   if (select ($rin, undef, undef,20)) {
    $line = <SOCK>;
    } else {croak "Timeout in SendMessage\n"}

    kill("TERM" => $kidpid);        # send SIGTERM to child
}
else {
    # child send message to the socket
    print SOCK "$Msg $id\n";
    exit;
}
 return "";
}

#-----------------------------------------------------------------------------------


#print file i n HTML
sub show_file {
 my $filename = shift;
 if (open (FILE, "<$filename") && (my @content = <FILE>) && (close FILE)) {
 foreach my $line (@content) {
  chomp ($line);
  print "$line<BR>\n";
  }
 }
}

#show command in HTML
sub show_command {
my $command=shift;
if (open (FILE,"$command 2>&1 |") && (my @content=<FILE>) && (close FILE)) {
  foreach my $line (@content) {
   chomp ($line);
   print "$line<BR>";
  }
 }

}

#load page index with descriptions
sub get_page_index {
  my $Ref = shift;
  my $options =shift;

  my $indexfile=$config {'PAGE_INDEX'};
  if (open (FILE, "<$indexfile") && (my @pgindex=<FILE>) && (close FILE)) {
   foreach my $line (@pgindex) {
	chomp ($line);
	my ($key, $value) = split (/=/,$line,2);
	if ( ! defined ($options)) {
	 #change to default page name if exists
	$value =~ s/\@\@(\w+_PAGE)\@\@/$dict{$1}/ if ($value =~ /\@\@(\w+_PAGE)\@\@/ );
	}

	$Ref -> {$key} = $value;
  }
  }
}


#register object class
sub RegisterClass {
 my $name = shift;
 my $dir = shift;
 my $langfile = shift;
 my $desc = shift;
 my $constructor = shift;

 $Classes {$name} = [ $dir, $langfile, $desc, $constructor ];
}

#create object by class name
sub CreateObjByClass {
 my $classname = shift;
 my $ret;
 if (defined ($Classes {$classname})) { #if registred
  my $classdesc=$Classes {$classname};
  my $classconstuctor = $$classdesc [3];
  #run constructor
  $ret = $classconstuctor -> ();
 }
 return ($ret);
}

#get names of all clases with description
sub GetClassesNames {
 my $RefHash = shift;
 foreach my $classname ( keys %Classes ) {
  my $cd = $Classes {$classname};
  #load description
  LoadLangData ($$cd[0],$$cd[1]);
  #extract class description
  $RefHash->{$classname} = $dict {$$cd[2]};
 }

}


#convert value to Kilo, Mega, Giga
sub ConvB {
 my $data = shift;
 my $res='';
 my @mul=('K','M','G','T','P'); #table prefixes
  if ($data < 1024) {
  $res = int ( $data);
 } else {
 my $i=-1;
 do {
  $data /= 1024;
  # my $kas=/"/";
  $i++;
  } until  ($data < 1024);
  if ($data < 10) {
  $res = sprintf ("%.2f", $data);
  } elsif ($data < 100)  {
  $res = sprintf ("%.1f", $data);
  } else {$res = int ($data)}

  $res .= $mul[$i]; #add prefix
 }

 my $sp =  " " x (6 -length ($res));
 $res =$sp.$res; #add spaces
 return $res;
}


1;
__END__






